/*
Cration dans la base  tpmarquedeposees :
- d'un schma donnees qui contient les tables  pays, classe, societe,marque
- cration d'un schma par utilisateur dans cette base
*/


drop database tpmarquedeposees;
create database tpmarquedeposees ;
\c tpmarquedeposees;

-- Cration dans la base  tpmarquedeposees d'un schma donne

create schema donnees;
set search_path to donnees, public ;



-- Initialisation du schma

DROP TABLE marque ;
DROP TABLE societe ;
DROP TABLE classe  ;
DROP TABLE Pays;


CREATE TABLE classe (
	num  INT  NOT NULL PRIMARY KEY,
	libelle VARCHAR(30)  NOT NULL
	);
\copy classe from 'Tables/classe'

CREATE TABLE pays (
	code  CHAR(2) NOT NULL PRIMARY KEY,
	nom  VARCHAR(50)
	);
\copy pays from 'Tables/pays'


CREATE TABLE societe (
	id  INT  NOT NULL PRIMARY KEY,
	nom VARCHAR(40)  NOT NULL,
	ville VARCHAR(20),
	pays CHAR(2)  NOT NULL REFERENCES pays
	);
\copy societe from 'Tables/societe'


CREATE TABLE marque (
        id  INT NOT NULL  PRIMARY KEY,
        nom VARCHAR(30)  NOT NULL,
        classe INT  NOT NULL REFERENCES classe,
        pays CHAR(2)  NOT NULL REFERENCES pays,
        prop INT  NOT NULL REFERENCES societe
        );

\copy  marque from 'Tables/marque'

					  
-- Mise en places des droits sur les tables du schema donnees
grant usage  on  schema donnees to public; -- pour que les relations du schema soient visibles

grant select on table pays to public;
grant references on table pays to public;
grant select on table societe to public;
grant references on table societe to public;
grant select on table classe to public;
grant references on table classe to public;
grant select on table marque to public;
grant references on table marque to public;


-- Cration des schema pour les utilisteurs
	
create schema authorization test;  
alter user test set search_path to test, donnees, public ; 


/*
\i schema_essi2;
-- schema_essi2 est gnr  partir du script script_schema_db et du fichier ml_essi2_04 et cr un schma pour chaque tudiant
                    
*/		    
