
-- TP2:  Phase 4


DROP SEQUENCE seq_idm;
DROP Table tmp_grp; 
DROP SEQUENCE seq_groupe;


-- Etape 4 : remplissage des tables

-- Suppression des anciennes valeurs 
delete from depots;
delete from marque_new;
delete from groupes_societes;
delete from groupes;


-- Groupes:
-- creation de la sequence des groupes 

CREATE SEQUENCE seq_groupe START  1 INCREMENT  1;

-- creation d'une table temporaire tel que (num_dep,pays)<-> idg
-- (il s'agit d'un majorant du nombre de groupes)

CREATE TEMPORARY TABLE tmp_grp  
(	idg     INT NOT NULL,
	ndep    INT NOT NULL, -- ndep et pays : utiles pour l'identification d'un dpot
        Pays 	varchar(50) NOT NULL
);

-- INSERT INTO tmp_grp (SELECT nextval('seq_groupe'), T.numdep, T.pays
--	FROM (SELECT DISTINCT  D.num_dep AS numdep, D.pays AS pays 
--		FROM depots_init1 D) AS T); 
--INSERT 0 77 

INSERT INTO  tmp_grp 
       SELECT  nextval('seq_groupe'),D.num_dep, D.pays
       FROM (SELECT  num_dep, pays
		     FROM depots_init1
		     GROUP BY num_dep, pays) AS D;


INSERT INTO  Groupes SELECT idg FROM tmp_grp; 
--INSERT 0 77

-- Societes (on suppose que les societs qui font des dpots existent dans la table socit)

-- Groupes_societes
INSERT INTO Groupes_societes (IdGroupe, IdSociete)
	SELECT G.idg, T.deposant
	FROM  tmp_grp AS G, deposants_init AS T
	WHERE  G.ndep = T.num_dep 
			AND G.pays = T.pays;
--INSERT 0 79

-- Marques
-- on cree une sequence des id. de marque pour que ceux-ci verifient 
-- la contrainte sur le nombre de chiffres

create sequence seq_idm start  10000 increment  1 MAXVALUE 99999;

insert into marque_new 
	select nextval('seq_idm'), NOM, CLASSE,'n', PAYS from marque M;
--INSERT 0 92

--Depots
-- on cree la sequence des id de depots qui est locale a ce schema


insert into depots 
	select  D.num_dep, P.code, D.Date_dep, M.idMarque,G.idg
	from depots_init1 D, marque_new M,  tmp_grp G, pays P
	where M.nom = D.nom 
		and M.classe = D.classe
		and M.pays = P.code 
		and P.nom= D.pays
		and G.ndep = D.num_dep
		and G.pays = D.pays
;
--INSERT 0 77

-- Mise  jour du statut dans marque_new 
-- (les groupes ne sont pas mis  jour car une groupe ne devient propritaire que lors de l'enregistrement de la marque)

UPDATE  marque_new  SET statut = 'd'
     WHERE IdMarque in (select D.IdMarque from depots D );
-- UPDATE 77
